/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.projects.model.tables.interfaces


import javax.annotation.Generated
import javax.validation.constraints.NotNull
import javax.validation.constraints.Size
import java.io.Serializable
import java.sql.Date


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:57:05.285Z", comments = "This class is generated by jOOQ")
interface IProject : Serializable {

    /**
     * Getter for `public.project.id`.
     */
    /**
     * Setter for `public.project.id`.
     */
    var id: Long?

    /**
     * Getter for `public.project.name`.
     */
    /**
     * Setter for `public.project.name`.
     */
    @get:NotNull
    @get:Size(max = 200)
    var name: String

    /**
     * Getter for `public.project.description`.
     */
    /**
     * Setter for `public.project.description`.
     */
    var description: String

    /**
     * Getter for `public.project.homepage`.
     */
    /**
     * Setter for `public.project.homepage`.
     */
    @get:Size(max = 120)
    var homepage: String

    /**
     * Getter for `public.project.created`.
     */
    /**
     * Setter for `public.project.created`.
     */
    var created: Date

    /**
     * Getter for `public.project.shortdesc`.
     */
    /**
     * Setter for `public.project.shortdesc`.
     */
    @get:Size(max = 200)
    var shortdesc: String

    /**
     * Getter for `public.project.category`.
     */
    /**
     * Setter for `public.project.category`.
     */
    @get:Size(max = 60)
    var category: String

    /**
     * Getter for `public.project.language`.
     */
    /**
     * Setter for `public.project.language`.
     */
    @get:Size(max = 20)
    var language: String

    /**
     * Getter for `public.project.license_id`.
     */
    /**
     * Setter for `public.project.license_id`.
     */
    var licenseId: Long?

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * Load data from another generated Record/POJO implementing the common interface IProject
     */
    fun from(from: IProject)

    /**
     * Copy data into another generated Record/POJO implementing the common interface IProject
     */
    fun <E : IProject> into(into: E): E
}
